<?php

include(file_exists('/usr/local/php/beroConf.php') ? '/usr/local/php/beroConf.php' : '/usr/fallback/beroConf.php');
include('/home/admin/lib/php/beroGui.class.php');
// include('/home/admin/www/include/gui_base.php');

function get_userappfs_version () {

	if (file_exists('/home/admin/VERSION')) {
		foreach(file('/home/admin/VERSION/') as $line) {
			if (preg_match('/VERSION=([0-9]*)/', $line, $res)) {
				return($res[1]);
			}
		}
	}

	return('unknown');
}

function get_apps_enabled ($root_db) {

	$apps_enabled = $root_db->get("root", "userapp-enabled");

	return((empty($apps_enabled) || $apps_enabled == 0) ? 0 : 1);
}

function get_app_size ($app_name) {

	$ret		= 0;
	$app_dir	= '/apps/' . $app_name;

	if (!empty($app_name)) {

		exec("du -xks " . $app_dir . " | awk '{ print $1; }'", $out_app);
		return($out_app[0]);
	}

	return(0);
}

function get_app_desc ($appname) {

	$ret		= 0;
	$src_dir	= "/apps";

	if (!empty($appname)) {
		$file = $src_dir . "/" . $appname . "/VERSION";

		if ($fh = @fopen($file, "r")) {

			$fconts = fread($fh, filesize($file));
			fclose($fh);

			preg_match("/DESCRIPTION=\"(.*)\"\n/", $fconts, $res);
			$ret = $res[1];
		}
	}

	return($ret);
}

function get_app_vers ($appname) {

	$ret		= 0;
	$src_dir	= "/apps";

	if (!empty($appname)) {
		$file = $src_dir . "/" . $appname . "/VERSION";

		if ($fh = @fopen($file, "r")) {

			$fconts = fread($fh, filesize($file));
			fclose($fh);

			preg_match("/VERSION=([0-9]*)/", $fconts, $res);
			$ret = $res[1];
		}
	}

	return($ret);
}

function print_form_settings ($root_db) {

	$div_l =	"<div style=\"margin-left: 5px; float: left; width: 200px; font-weight: bold;\">";
	$div_r =	"<div style=\"float: right; width: 125px;\">";
	$div_checkbox =	"<div style=\"width: 450px;\">";

	$app_en = $root_db->get('root', 'userapp-enabled');

	$ret =	"<br />\n" .
		"<h2>UserApp Settings</h2>\n" .
		"<form class=\"extensions_form\" name=\"app_form_settings\" action=\"index.php\"  method=\"POST\">\n" .
		"\t<div style=\"width: 100%\">\n" .
		"\t\t" . $div_r . "\n" .
		"\t\t\t<input type=\"hidden\" name=\"app_form_save\" value=\"1\" />\n" .
		"\t\t\t<input type=\"submit\" value=\"Apply\" />\n" .
		"\t\t</div>\n" .
		"\t\t" . $div_l . "Enable support for UserApps:</div>\n" .
       		"\t\t" . $div_checkbox . "<input type=\"checkbox\" name=\"app_en\" value=\"1\"" . ($app_en == 1 ? " checked" : "") . " /></div>\n";

	 if ($app_en) {
		$app_user_en = $root_db->get('root', 'userapp-user-enabled');

		$ret .=	"\t\t" . $div_l . "Enable SSH-Login:</div>\n" .
			"\t\t" . $div_checkbox . "<input type=\"checkbox\" name=\"app_user_en\" value=\"1\"" . ($app_user_en == 1 ? " checked" : "") . " /></div>\n";

		if ($app_user_en == 1) {
			$ret .=	"\t\t" . $div_l . "Set password for SSH-Login:</div>\n" .
				"\t\t" . $div_checkbox . "<input type=\"password\" name=\"app_user_pw_set\" /></div>\n" .
			   	"\t\t" . $div_l . "Reset password for SSH-Login:</div>\n" .
				"\t\t" . $div_checkbox . "<input type=\"checkbox\" name=\"app_user_pw_res\" value=\"1\" /></div>\n";
		}
	}

	$ret .=	"\t</div>\n" .
		"</form>\n";

	return($ret);

}

function print_form_uins ($name) {

	$ret =	"<form class=\"extensions_form\" action=\"index.php\" name=\"app_uins\" method=\"POST\">\n" .
		"\t<input type=\"hidden\" name=\"app_name\" value=\"" . $name . "\" />\n" .
		"\t<input type=\"submit\" name=\"uninstall\" value=\"Uninstall\" onclick=\"if (confirm('Do you really want to uninstall " . $name . "?') == false) { return(false); }\" />\n" .
		"</form>\n";

	return($ret);
}

function print_form_ins () {

	$ret =	"<form class=\"extensions_form\" action=\"/app/berogui/index.php\" name=\"app_ins\" method=\"GET\">\n" .
		"\t<input type=\"hidden\" name=\"m\" value=\"up_tool\" />\n" .
		"\t<input type=\"submit\" value=\"Install\" />\n" .
		"</form>\n";

	return($ret);
}

function get_apps_state ($root_db) {

	$ret =	"<br />\n" .
		"<h2>UserApp State</h2>\n";

	if ($root_db->get('root', 'userapp-enabled') == 1) {
		$ret .= 	"<form class=\"extensions_form\" action=\"index.php\" name=\"app_res\" method=\"POST\">\n" .
				"\t<div style=\"float: right; width: 125px;\">\n" .
				"\t\t<input type=\"hidden\" name=\"app_services_restart\" value=\"1\" />\n" .
				"\t\t<input type=\"submit\" value=\"Restart\" />\n" .
				"\t</div>\n" .
				"</form>\n";
	}

	$ret .=	"<div style=\"margin-left: 5px; font-weight: bold;\">UserApps are currently ";

	switch($root_db->get('root', 'userapp-status')) {
	case 'running':
		$ret .= "<span style=\"color: green;\">running</span>";
		break;
	case 'stopped':
		$ret .= "<span style=\"color: red;\">stopped</span>";
		break;
	case 'disabled':
		$ret .= "<span style=\"color: red;\">disabled</span>";
		break;
	}

	$ret .= ".</div>\n";

	return($ret);
}

function get_fstab_mount_mode ($mountpoint) {

	foreach (file('/etc/fstab') as $line) {
		if (preg_match('/' . str_replace('/', '\/', $mountpoint) . '/', $line)) {
			if (strstr($line, 'ro,defaults') != false) {
				return(0);
			} else if (strstr($line, 'rw,defaults') != false) {
				return(1);
			}
		}
	}
}

function set_fstab_mount_mode ($mountpoint, $mode) {

	$write = false;

	foreach (file('/etc/fstab') as $line) {
		if (preg_match('/' . str_replace('/', '\/', $mountpoint) . '/', $line)) {
			switch ($mode) {
			default:
			case 'ro':
				if (strstr($line, 'rw,defaults,') != false) {
					$fstab_out .= str_replace('rw,defaults,', 'ro,defaults,', $line);
					$write = true;
				}
				break;
			case 'rw':
				if (strstr($line, 'ro,defaults,') != false) {
					$fstab_out .= str_replace('ro,defaults,', 'rw,defaults,', $line);
					$write = true;
				}
				break;
			}
		} else {
			$fstab_out .= $line;
		}
	}

	if ($write == true) {
		exec('/bin/mount -oremount,rw /');
		$fp = fopen('/etc/fstab', 'w');
		fwrite($fp, $fstab_out);
		fclose($fp);
		exec('/bin/mount -oremount,ro /');
	}
}

function show_developer_options ($root_db) {

	$div_l	= "<div style=\"margin-left: 5px;float: left; width: 200px; font-weight: bold;\">";
	$div_r	= "<div style=\"float: right; width: 125px;\">";


	if ($root_db->get('root', 'userapp-enabled') == 1) {

		$ret =  "<br />\n<h2>Developer Options</h2>\n" .
			"<form class=\"extensions_form\" action=\"index.php\" name=\"app_mount_mode\" method=\"POST\">\n" .
			"\t" . $div_r . "\n" .
			"\t\t<input type=\"hidden\" name=\"app_mount_rw\" value=\"1\" />\n" .
			"\t\t<input type=\"submit\" value=\"Apply\" />\n" .
			"\t</div>\n" .
			"\t" . $div_l . "Remount UserAppFS R/W</div><br />\n" .
			"\t" . $div_l . "Permanent R/W:</div>\n" .
			"\t<input type=\"checkbox\" name=\"app_mount_rw_perm\" value=\"1\"" . (get_fstab_mount_mode('/home/admin') ? ' checked="checked"' : '') . " />\n" .
			"</form>\n";
	}

	return($ret);
}

function get_app_links () {

	$apps = array();

	if ($dh = opendir('/apps')) {
		while (($file = readdir($dh)) !== false) {
			if ($file != ".." && $file != ".") {
				$tmp['title'] = $file;
				$tmp['url'] = '/userapp/' . $file;
				$tmp['id'] = 'app_' . $file;
				$apps[] = $tmp;
			}
		}

		closedir($dh);
	}

	return($apps);
}

function print_app_installed () {

	$apps = array();

	if ($dh = opendir("/apps")) {
		while (($file = readdir($dh)) !== false) {
			if ($file != ".." && $file != ".") {
				$tmp['name'] = $file;
				$tmp['size'] = get_app_size($file);
				$tmp['desc'] = get_app_desc($file);
				$tmp['vers'] = get_app_vers($file);
				$apps[] = $tmp;
			}
		}

		closedir($dh);
	}

	$ret =	"<br /><br />\n" .
		"<table class=\"contenttoc\" width=\"95%\">\n" .
		"\t<tr style=\"background-color: rgb(235,223,223);\">\n" .
		"\t\t<th colspan=\"5\">Installed Apps</th>\n" .
		"\t</tr>\n" .
		"\t<tr style=\"background-color: rgb(240,240,236); font-weight: bold;\">\n" .
		"\t\t<td>Name</td>" .
		"\t\t<td>Version</td>" .
		"\t\t<td>Description</td>" .
		"\t\t<td>Size</td>\n" .
		"\t\t<td>Action</td>\n" .
		"\t</tr>\n";

	if (!empty($apps)) {
		foreach ($apps as $app) {
			$ret .= "\t<tr>\n" .
				"\t\t<td><a href=\"" . $app['name'] . "\">" . $app['name'] . "</a></td>\n" .
				"\t\t<td>" . $app['vers'] . "</td>\n" .
				"\t\t<td style=\"white-space: nowrap;\">" . $app['desc'] . "</td>\n" .
				"\t\t<td>" . $app['size'] . "K</td>\n" .
				"\t\t<td>\n" .
				print_form_uins($app['name']) .
				"\t\t</td>\n" .
				"\t</tr>\n";
		}
	}

	$ret .= "\t<tr>\n" .
		"\t\t<td colspan=\"5\">\n" .
		print_form_ins() .
		"\t\t</td>\n" .
		"\t</tr>\n" .
		"</table>\n";

	return($ret);
}

function print_app_mounts () {

	$ret =	"<br /><br />\n" .
		"<table class=\"contenttoc\" width=\"95%\">\n" .
		"\t<tr style=\"background-color: rgb(235,223,223);\">\n" .
		"\t\t<th colspan=\"4\">Remote Shares</th>\n" .
		"\t</tr>\n" .
		"\t<tr style=\"background-color: rgb(240,240,236);\">\n" .
		"\t\t<td><b>Remote</b></td>\n" .
		"\t\t<td><b>Local</b></td>\n" .
		"\t\t<td><b>Type</b></td>\n" .
		"\t\t<td><b>Mounted</b></td>\n" .
		"\t</tr>\n";

	if (!($dh = opendir('/apps/'))) {
		return;
	}

	while ($sub = readdir($dh)) {

		if (($sub == '.') || ($sub == '..')) {
			continue;
		}

		if ($sub_fs = @file('/apps/' . $sub . '/etc/fstab')) {

			foreach ($sub_fs as $line) {

				if ($line[0] == '#') {
					continue;
				}

				$field = explode("\t", $line);

				exec('/bin/mount | grep ' . $field[0], $tmp, $mounted);

				$ret .=	"\t<tr>\n" .
					"\t\t<td>" . $field[0] . "</td>\n" .
					"\t\t<td>/apps/" . $sub . $field[1] . "</td>\n" .
					"\t\t<td>" . $field[2] . "</td>\n" .
					"\t\t<td>" . ($mounted == 0 ? "yes" : "no") . "</td>\n" .
					"\t</tr>\n";
			}
		}
	}

	closedir($dh);

	$ret .=	"</table>\n";

	return($ret);
}

function print_userappfs_version () {

	$ret =	"<br />\n" .
		"<div style=\"background-color: transparent; color: grey; float: right; width: 200px; text-align: right; font-size: 10px; margin-right: 40px;\">\n" .
		"\tUserAppFS Version " . get_userappfs_version() . "\n" .
		"</div>\n";

	return($ret);
}

function print_app_space () {

	exec("df | grep /home/admin | awk '{ print $2; }'", $out_all);
	$all = $out_all[0];

	exec("df | grep /home/admin | awk '{ print $3; }'", $out_used);
	$used = $out_used[0];

	$percent_used = round(($used * 100) / $all);

	$ret =	"<br /><br />\n" .
		"<table style=\"border-style: none; border-spacing: 0px; border-collapse: collapse; margin-left: auto; margin-right: auto; max-width: 95%;\" width=\"95%\">\n" .
		"\t<tr>\n" .
		"\t\t<th style=\"border: none;\" colspan=\"100\">Disk Usage</th>\n" .
		"\t</tr>\n" .
		"\t<tr>\n";

	for ($i = 1; $i <= 100; $i++) {

		if ($i <= $percent_used) {
			$style = "background-color: red; border: none; color: black; font-size: 3px; height: 5px; width: 2px;";
		} else {
			$style = "background-color: green; border: none; color: black; font-size: 3px; height: 5px; width: 2px;";
		}

		$ret .= "\t\t<td style=\"" . $style . "\">&nbsp;</td>\n";
	}

	$ret .=	"\t</tr>\n" .
		"\t<tr>\n" .
		"\t\t<td colspan=\"25\" style=\"background-color: transparent; border: none; text-align: left;\">0%</td>\n" .
		"\t\t<td colspan=\"50\" style=\"background-color: transparent; border: none; text-align: center;\">" . $percent_used . "% used</td>\n" .
		"\t\t<td colspan=\"25\" style=\"background-color: transparent; border: none; text-align: right;\">100%</td>\n" .
		"\t</tr>\n" .
		"</table>\n";

	return($ret);
}

function app_save_settings ($root_db, $conf) {

	$root_db->set('root', 'userapp-enabled', $conf['app_en']);
	$root_db->set('root', 'userapp-user-enabled', (($conf['app_en'] == 1) ? $conf['app_user_en'] : 0));

	if (isset($conf['app_user_pw_set'])) {
		exec('/usr/local/sbin/pwchange.sh admin ' . $conf['app_user_pw_set']);
	}

	if ($conf['app_user_pw_res']) {
		exec('/usr/local/sbin/reset_admin_passwd.sh');
	}

	exec('/etc/init.d/S91userapp update-user');

	switch($root_db->get('root', 'userapp-status')) {
	case 'running':
		if ($conf['app_en'] == 0) {
			exec('/etc/init.d/S91userapp stop');
		}
		break;
	case 'stopped':
		if ($conf['app_en'] == 1) {
			exec('/etc/init.d/S91userapp start');
		}
		break;
	}
}

include('/home/admin/lib/php/session.php');

$root_db = new beroConf('root');

if (!$root_db->valid()) {
	$body	= "Invalid or damaged root.db!";
} else {

	if (isset($_POST['app_form_save'])) {
		app_save_settings($root_db, $_POST);
	}

	if (isset($_POST['uninstall'])) {
		exec('/usr/local/sbin/userapp_uninstall.sh ' . $_POST['app_name']);
	}

	if (isset($_POST['app_services_restart'])) {
		exec('/etc/init.d/S91userapp restart');
	}

	if (isset($_POST['app_mount_rw'])) {
		exec('mount -oremount,rw /home/admin');

		set_fstab_mount_mode('/home/admin', (($_POST['app_mount_rw_perm'] == 1) ? 'rw' : 'ro'));
	}

	$body =	print_form_settings($root_db).
		get_apps_state($root_db) .
		show_developer_options($root_db);

	if (get_apps_enabled($root_db)) {
		$body .= print_app_installed() .
			 print_app_space() .
			 print_app_mounts() .
			 print_userappfs_version();
	}
}

$bg = new beroGUIv2('UserApp Management');

echo $bg->get_MainHeader(get_app_links(), null) . $body . $bg->get_MainFooter();

?>
